## ironseed 0.1.0

=== DESCRIPTION ===
Package: ironseed
Title: Improved Random Number Generator Seeding
Version: 0.1.0
Authors@R: 
    person("Reed", "Cartwright",
           role = c("aut", "cre"),
           email = "racartwright@gmail.com",
           comment = c(ORCID = "0000-0002-0837-9380"))
Description: A procedure for seeding R's built in random number
    generators using a variable-length sequence of values.
    Accumulates input entropy into a 256-bit hash digest or "ironseed"
    and is able to generate a variable-length sequence of output seeds
    from an ironseed.
License: MIT + file LICENSE
Language: en-US
Encoding: UTF-8
RoxygenNote: 7.3.2
Biarch: TRUE
NeedsCompilation: yes
URL: https://github.com/reedacartwright/ironseed
BugReports: https://github.com/reedacartwright/ironseed/issues
Suggests: tinytest
Packaged: 2025-07-06 21:50:57 UTC; reed
Author: Reed Cartwright [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-0837-9380>)
Maintainer: Reed Cartwright <racartwright@gmail.com>
Repository: CRAN
Date/Publication: 2025-07-11 08:40:02 UTC

## ironseed 0.2.0

=== DESCRIPTION ===
Package: ironseed
Title: Improved Random Number Generator Seeding
Version: 0.2.0
Authors@R: 
    c(person("Reed", "Cartwright",
             role = c("aut", "cre"),
             email = "racartwright@gmail.com",
             comment = c(ORCID = "0000-0002-0837-9380")),
      person("National Science Foundation DBI-1929850",
             role = "fnd"))
Description: A procedure for seeding R's built in random number
    generators using a variable-length sequence of values.
    Accumulates input entropy into a 256-bit hash digest or "ironseed"
    and is able to generate a variable-length sequence of output seeds
    from an ironseed.
License: MIT + file LICENSE
Language: en-US
Encoding: UTF-8
RoxygenNote: 7.3.2
Biarch: TRUE
NeedsCompilation: yes
URL: https://github.com/reedacartwright/ironseed
BugReports: https://github.com/reedacartwright/ironseed/issues
Suggests: tinytest
Packaged: 2025-08-20 21:54:41 UTC; reed
Author: Reed Cartwright [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-0837-9380>),
  National Science Foundation DBI-1929850 [fnd]
Maintainer: Reed Cartwright <racartwright@gmail.com>
Repository: CRAN
Date/Publication: 2025-08-20 22:10:01 UTC

## ironseed 0.3.0

=== DESCRIPTION ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Package: ironseed
 Title: Improved Random Number Generator Seeding
-Version: 0.2.0
+Version: 0.3.0
 Authors@R: 
     c(person("Reed", "Cartwright",
              role = c("aut", "cre"),
@@ -16,16 +16,16 @@
 License: MIT + file LICENSE
 Language: en-US
 Encoding: UTF-8
-RoxygenNote: 7.3.2
+RoxygenNote: 7.3.3
 Biarch: TRUE
 NeedsCompilation: yes
 URL: https://github.com/reedacartwright/ironseed
 BugReports: https://github.com/reedacartwright/ironseed/issues
 Suggests: tinytest
-Packaged: 2025-08-20 21:54:41 UTC; reed
+Packaged: 2025-11-18 22:54:06 UTC; reed
 Author: Reed Cartwright [aut, cre] (ORCID:
     <https://orcid.org/0000-0002-0837-9380>),
   National Science Foundation DBI-1929850 [fnd]
 Maintainer: Reed Cartwright <racartwright@gmail.com>
 Repository: CRAN
-Date/Publication: 2025-08-20 22:10:01 UTC
+Date/Publication: 2025-11-18 23:10:02 UTC

## ironseed 0.3.6

=== Makefile ===
DESTDIR  ?=
prefix   ?= /usr/local
bindir   ?= $(prefix)/games
libdir   ?= $(prefix)/lib/games/ironseed
sharedir ?= $(prefix)/share/games/ironseed
docdir   ?= $(prefix)/share/doc/ironseed
deskdir  ?= $(prefix)/share/applications
icondir  ?= $(prefix)/share/icons/hicolor/128x128/apps

CC	 ?= gcc
p_compiler:= fpc
d_compiler = gdc -g -funittest -fall-instantiations -o $@

# try to fall back to ldc if gdc is not installed
HAVE_GDC := $(shell command -v gdc 2> /dev/null)
ifndef HAVE_GDC
d_compiler = ldc2 -g -check-printf-calls -of=$@
endif

PFLAGS:= -Mtp -g -gl -gv
#-Aas -ap
fpc_debug:= -C3 -Ci -Co -CO  -O1 -gw -godwarfsets  -gt -vewnhiq   -Sa -Sy  -vm4049 -k--build-id
# enable fatal warnings/notes when developing
#fpc_debug += -Sewnh
# -O- -Cr -CR -Ct   -gh  -gc -dDEBUG  -dTrace
libgcc_dir := $(shell find /usr/ -name libgcc_s.so -printf "-Fl%h " 2>/dev/null)
PFLAGS += -k-lSDL_mixer -k-lSDL -k-lm $(libgcc_dir)

c_includes:=`sdl-config --cflags` -I /usr/X11R6/include
CFLAGS += -g -Wall -W -pedantic -Wno-unused-parameter -Wconversion $(c_includes)

# PIE etc. hardening wanted by Debian - see https://wiki.debian.org/Hardening
PFLAGS += -fPIC
CFLAGS += -fpic -D_FORTIFY_SOURCE=2
# automatically extract from: LDFLAGS=-Wl,-z,relro -Wl,-z,now
wlz=-Wl,-z,
ifneq (,$(findstring $(wlz)relro,$(LDFLAGS)))
PFLAGS += -k'-z relro'
endif
ifneq (,$(findstring $(wlz)now,$(LDFLAGS)))
PFLAGS += -k'-z now'
endif
ifneq (,$(findstring -pie,$(LDFLAGS)))
PFLAGS += -k-pie
endif


rebuild: clean all cleantmp
# default target to build, best is debug_sdl / debug_ogl (NOT "release_xxx" AKA "no-checks" versions!)
all: clearpaths debug_sdl1

cleanbuild: clean build cleantmp

# OpenGL no-checks version
release_ogl debug_ogl1: PFLAGS += -k-lGL -k-lGLU

release_ogl: CFLAGS += -O -DNDEBUG
release_ogl: cleanbuild

# OpenGL debug version
debug_ogl:   clean debug_ogl1 cleantmp
debug_ogl1:  CFLAGS += -O1 -Werror
debug_ogl1:  PFLAGS += $(fpc_debug)
debug_ogl1:  build

# SDL no-checks version
release_sdl: CFLAGS += -O -DNDEBUG -DNO_OGL
release_sdl: cleanbuild

# SDL debug version
debug_sdl1 demo_sdl1 data_build Data_Generators/makedata/iconmake Data_Generators/makedata/makeani Data_Generators/makedata/shp2make: CFLAGS += -O1 -DNO_OGL -Werror

debug_sdl:   clean debug_sdl1 cleantmp
debug_sdl1:  PFLAGS += $(fpc_debug)
debug_sdl1:  build

# DEMO SDL debug version
demo_sdl:    clean demo_sdl1 cleantmp
demo_sdl1:   PFLAGS += $(fpc_debug) -dDEMO
demo_sdl1:   build

PROG_FILES = is crewgen intro main
DATA_TOOLS_D = Data_Generators/makedata/convmake Data_Generators/makedata/logmake
DATA_TOOLS_P = Data_Generators/makedata/aliemake Data_Generators/makedata/artimake Data_Generators/makedata/cargmake Data_Generators/makedata/creamake Data_Generators/makedata/crewmake Data_Generators/makedata/elemmake Data_Generators/makedata/eventmak Data_Generators/makedata/itemmake Data_Generators/makedata/makename Data_Generators/makedata/scanmake Data_Generators/makedata/shipmake Data_Generators/makedata/sysmake Data_Generators/makedata/weapmake  Data_Generators/makedata/iconmake Data_Generators/makedata/namemake Data_Generators/makedata/makeani Data_Generators/makedata/shp2make Data_Generators/misc/scr2cpr Data_Generators/misc/cpr2scr Data_Generators/misc/cpr2tga Data_Generators/misc/tga2cpr

CREWCONVS := data/conv0001.dta data/conv0002.dta data/conv0003.dta data/conv0004.dta data/conv0005.dta data/conv0006.dta
RACECONVS := data/conv1001.dta data/conv1002.dta data/conv1003.dta data/conv1004.dta data/conv1005.dta data/conv1006.dta data/conv1007.dta data/conv1008.dta data/conv1009.dta data/conv1010.dta data/conv1011.dta
SPECCONVS := data/conv1100.dta data/conv1101.dta data/conv1102.dta data/conv1103.dta data/conv1000.dta
CPR_CREW0 := data/image01.cpr data/image02.cpr data/image03.cpr data/image04.cpr data/image05.cpr data/image06.cpr data/image07.cpr data/image08.cpr data/image09.cpr data/image10.cpr data/image11.cpr data/image12.cpr data/image13.cpr data/image14.cpr data/image15.cpr data/image16.cpr data/image17.cpr data/image18.cpr data/image19.cpr data/image20.cpr data/image21.cpr data/image22.cpr data/image23.cpr data/image24.cpr data/image25.cpr data/image26.cpr data/image27.cpr data/image28.cpr data/image29.cpr data/image30.cpr data/image31.cpr data/image32.cpr
CPR_MISC0 := data/trade.cpr data/end6.cpr data/waricon.cpr data/cloud.cpr Data_Generators/makedata/charani.cpr Data_Generators/makedata/shippart.cpr
CPR_SELFPAL1 := data/main.cpr data/main3.cpr data/end1.cpr data/end2.cpr data/end3.cpr data/end4.cpr data/end5.cpr data/alien.cpr data/alien1.cpr data/alien2.cpr data/alien3.cpr data/alien4.cpr data/alien5.cpr data/alien6.cpr data/alien7.cpr data/alien8.cpr data/alien9.cpr data/alien10.cpr data/demoscr2.cpr data/demoscr3.cpr data/demoscr4.cpr data/demoscrn.cpr data/cargo.cpr data/channel7.cpr data/fight.cpr data/intro2.cpr data/intro3.cpr data/intro5.cpr data/intro6.cpr data/battle1.cpr data/charcom.cpr data/saver.cpr data/ship1.cpr data/world.cpr data/char.cpr data/tech1.cpr data/sector.cpr data/landform.cpr data/psyche.cpr data/char2.cpr data/com.cpr data/log.cpr  data/back1.cpr data/back2.cpr data/back3.cpr data/back4.cpr data/back5.cpr data/back6.cpr data/back7.cpr data/back8.cpr data/back9.cpr data/back10.cpr data/back11.cpr Data_Generators/makedata/planicon.cpr
IMG_FILES := data/main.pal $(CPR_SELFPAL1) $(CPR_CREW0) $(CPR_MISC0)
DATA_FILES := data/log.dta  data/titles.dta $(CREWCONVS) $(RACECONVS) $(SPECCONVS) $(IMG_FILES) data/iteminfo.dta  data/cargo.dta data/creation.dta data/scan.dta data/sysname.dta data/contact0.dta data/crew.dta data/artifact.dta data/elements.dta data/event.dta data/weapon.dta data/weapicon.dta data/planicon.dta data/ships.dta data/planname.txt data/icons.vga data/charani.dta data/shippix.dta data/plan1.dta data/sysset.dta

build:  $(PROG_FILES) $(DATA_FILES)

c_utils.o: Makefile c_utils.c
	$(CC) $(CFLAGS) -c c_utils.c

$(PROG_FILES): Makefile c_utils.o _paths_.pas *.pas
	$(p_compiler) $(PFLAGS) $@.pas

test/test_0_c: clean Makefile c_utils.c test/test_0_c.c
	$(CC) $(CFLAGS) -O1 -Werror test/test_0_c.c `sdl-config --libs` -lSDL_mixer -lm -lGL -lGLU  -o test/test_0_c

test/test_0_pas: CFLAGS += -O1 -Werror
test/test_0_pas: PFLAGS += $(fpc_debug) -k-lGL -k-lGLU
test/test_0_pas: clean Makefile c_utils.o test/test_0_pas.pas
	$(p_compiler) $(PFLAGS) test/test_0_pas.pas

# needed because fpc does not have gcc-like -dVAR=VALUE syntax :(
_paths_.pas: Makefile
	echo "{ Autogenerated by Makefile, do not modify directly! }" > $@
	echo "Unit _paths_;" >> $@
	echo "INTERFACE" >> $@
	echo "function prog_libdir:string;" >> $@
	echo "function prog_sharedir:string;" >> $@
	echo "IMPLEMENTATION" >> $@
	echo "function prog_libdir:string; begin; prog_libdir:='$(libdir)'; end;" >> $@
	echo "function prog_sharedir:string; begin; prog_sharedir:='$(sharedir)'; end;" >> $@
	echo "begin end." >> $@

clearpaths:
	rm -f _paths_.pas

cleantmp: clearpaths
	find . -iname "*.ppu" -print0 | xargs -0r rm -f
	find . -iname "*.s" -print0 | xargs -0r rm -f

clean: cleantmp
	rm -f $(PROG_FILES)
	rm -f link.res
	find . -iname "*.o" -print0 | xargs -0r rm -f

cleanbak:
	find . -iname "*~" -print0 | xargs -0r rm -f
	find . -iname "*.bak" -print0 | xargs -0r rm -f

distclean: clean cleanbak
	rm -f $(DATA_TOOLS_D) $(DATA_TOOLS_P) tags
	rm -f test/test_0_c test/test_0_pas test/testdiv0 test/testkey1 test/testsize test/test_write test/filename
	rm -f LPT1 TEMP/* Data_Generators/misc/tga_head.bin
	touch TEMP/keep.c

reallyclean: distclean data_destroy
	-dh clean

mrproper: reallyclean
	rm -rf data/savegame.dir save?

tags: *.c *.pas
	ctags $^


Data_Generators/makedata/convmake: Data_Generators/makedata/convmake.d Data_Generators/makedata/data.d
Data_Generators/makedata/logmake: Data_Generators/makedata/logmake.d Data_Generators/makedata/data.d
$(DATA_TOOLS_D):
	$(d_compiler) $^

Data_Generators/makedata/aliemake: Data_Generators/makedata/aliemake.pas
Data_Generators/makedata/artimake: Data_Generators/makedata/artimake.pas
Data_Generators/makedata/cargmake: Data_Generators/makedata/cargmake.pas
Data_Generators/makedata/creamake: Data_Generators/makedata/creamake.pas
Data_Generators/makedata/crewmake: Data_Generators/makedata/crewmake.pas
Data_Generators/makedata/elemmake: Data_Generators/makedata/elemmake.pas
Data_Generators/makedata/eventmak: Data_Generators/makedata/eventmak.pas
Data_Generators/makedata/itemmake: Data_Generators/makedata/itemmake.pas
Data_Generators/makedata/makename: Data_Generators/makedata/makename.pas
Data_Generators/makedata/scanmake: Data_Generators/makedata/scanmake.pas
Data_Generators/makedata/shipmake: Data_Generators/makedata/shipmake.pas
Data_Generators/makedata/sysmake: Data_Generators/makedata/sysmake.pas
Data_Generators/makedata/weapmake: Data_Generators/makedata/weapmake.pas
Data_Generators/makedata/iconmake: Data_Generators/makedata/iconmake.pas c_utils.o data.pas utils_.pas _paths_.pas
Data_Generators/makedata/namemake: Data_Generators/makedata/namemake.pas
Data_Generators/makedata/makeani: Data_Generators/makedata/makeani.pas   c_utils.o data.pas utils_.pas _paths_.pas
Data_Generators/makedata/shp2make: Data_Generators/makedata/shp2make.pas c_utils.o data.pas utils_.pas _paths_.pas

Data_Generators/misc/scr2cpr: Data_Generators/misc/scr2cpr.pas Data_Generators/misc/data2.pas
Data_Generators/misc/cpr2scr: Data_Generators/misc/cpr2scr.pas Data_Generators/misc/data2.pas
Data_Generators/misc/cpr2tga: Data_Generators/misc/cpr2tga.pas Data_Generators/misc/data2.pas
Data_Generators/misc/tga2cpr: Data_Generators/misc/tga2cpr.pas Data_Generators/misc/data2.pas

$(DATA_TOOLS_P):
	$(p_compiler) $(PFLAGS)  $<

data/log.dta  data/titles.dta: Data_Generators/makedata/logmake Data_Generators/makedata/logs.txt
	Data_Generators/makedata/logmake Data_Generators/makedata/logs.txt data/titles.dta data/log.dta


data/conv%.dta:
	Data_Generators/makedata/convmake $< $(subst .dta,,$@)

data/conv1000.dta:
	touch data/conv1000.dta data/conv1000.ind

data/conv0001.dta: Data_Generators/makedata/crewcon1.txt Data_Generators/makedata/convmake
data/conv0002.dta: Data_Generators/makedata/crewcon2.txt Data_Generators/makedata/convmake
data/conv0003.dta: Data_Generators/makedata/crewcon3.txt Data_Generators/makedata/convmake
data/conv0004.dta: Data_Generators/makedata/crewcon4.txt Data_Generators/makedata/convmake
data/conv0005.dta: Data_Generators/makedata/crewcon5.txt Data_Generators/makedata/convmake
data/conv0006.dta: Data_Generators/makedata/crewcon6.txt Data_Generators/makedata/convmake

data/conv1001.dta: Data_Generators/makedata/sengcon1.txt Data_Generators/makedata/convmake
data/conv1002.dta: Data_Generators/makedata/dpahcon1.txt Data_Generators/makedata/convmake
data/conv1003.dta: Data_Generators/makedata/aardcon1.txt Data_Generators/makedata/convmake
data/conv1004.dta: Data_Generators/makedata/ermicon1.txt Data_Generators/makedata/convmake
data/conv1005.dta: Data_Generators/makedata/titecon1.txt Data_Generators/makedata/convmake
data/conv1006.dta: Data_Generators/makedata/quacon1.txt  Data_Generators/makedata/convmake
data/conv1007.dta: Data_Generators/makedata/scavcon1.txt Data_Generators/makedata/convmake
data/conv1008.dta: Data_Generators/makedata/iconcon1.txt Data_Generators/makedata/convmake
data/conv1009.dta: Data_Generators/makedata/guilcon1.txt Data_Generators/makedata/convmake
data/conv1010.dta: Data_Generators/makedata/mochcon1.txt Data_Generators/makedata/convmake
data/conv1011.dta: Data_Generators/makedata/voidcon1.txt Data_Generators/makedata/convmake

data/conv1100.dta: Data_Generators/makedata/tek2con1.txt Data_Generators/makedata/convmake
data/conv1101.dta: Data_Generators/makedata/tek3con1.txt Data_Generators/makedata/convmake
data/conv1102.dta: Data_Generators/makedata/tek4con1.txt Data_Generators/makedata/convmake
data/conv1103.dta: Data_Generators/makedata/tek5con1.txt Data_Generators/makedata/convmake

data/charani.dta:     Data_Generators/makedata/makeani data/char.cpr Data_Generators/makedata/charani.cpr

=== debian/changelog ===
ironseed (0.3.6-5) unstable; urgency=medium

  * mipsel architecture does not yet have working gdc (see Bug#980204),
    so skip rebuild of game datafiles which require that for now.

 -- Matija Nalis <mnalis-deb@voyager.hr>  Sat, 16 Jan 2021 04:00:00 +0100

ironseed (0.3.6-4) unstable; urgency=medium

  * enable extra little-endian architectures theoretically supported by
    freepascal (mipsel mips64el kfreebsd-amd64 kfreebsd-i386 riscv64)

 -- Matija Nalis <mnalis-deb@voyager.hr>  Thu, 14 Jan 2021 03:44:28 +0100

ironseed (0.3.6-3) unstable; urgency=medium

  * enable ppc64el architecture too

 -- Matija Nalis <mnalis-deb@voyager.hr>  Sat, 09 Jan 2021 01:37:01 +0100

ironseed (0.3.6-2) unstable; urgency=medium

  * update debian/rules for faster startup, due to lintian warning
    debian-rules-sets-dpkg-architecture-variable
  * build AND test only on known-to-work architectures
  * change DEB_HOST_ARCH Makefile variable name, as it has reserved &
    unintended side effects (which made armhf/armel packages uninstallable)

 -- Matija Nalis <mnalis-deb@voyager.hr>  Tue, 05 Jan 2021 09:55:58 +0100

ironseed (0.3.6-1) unstable; urgency=medium

  * ppc64el architecture does not yet have working gdc (see Bug#978153),
    so skip rebuild of game datafiles which require it, for now.
  * try for "Architecture: any" again, as droping ppc64el didn't help with
    migration to testing, and upstream 0.3.6 should be able to build on more
    architectures (like mipsel)
  * extra build hardening on amd64 (-pie)
    https://wiki.debian.org/Hardening
  * declare test as flaky for now, until we figure out ppc64el failures
  * New upstream release

 -- Matija Nalis <mnalis-deb@voyager.hr>  Tue, 05 Jan 2021 08:07:49 +0100

ironseed (0.3.5-2) unstable; urgency=medium

  * limit architectures on which we successfully build, to avoid being
    blocked for migration to testing (due to ppc64el erroneously being
    marked as autopkgtest failure, while package was never even built
    successfully on that architecture)
  * providing "Multi-Arch: foreign" even for "Architecture: all"
    ironseed-data, as suggested by:
    https://tracker.debian.org/pkg/ironseed
    https://wiki.debian.org/MultiArch/Hints

 -- Matija Nalis <mnalis-deb@voyager.hr>  Thu, 31 Dec 2020 00:22:10 +0100

ironseed (0.3.5-1) unstable; urgency=medium

  * New upstream release
  * do not fail when removing duplicate manpage if it is already gone

 -- Matija Nalis <mnalis-deb@voyager.hr>  Sun, 27 Dec 2020 03:34:52 +0100

ironseed (0.3.4-1) unstable; urgency=medium

  * New upstream release
  * implement basic working autopkgtest (start game, check savefiles)

 -- Matija Nalis <mnalis-deb@voyager.hr>  Tue, 15 Dec 2020 04:32:55 +0100

ironseed (0.3.2-2) unstable; urgency=low

  * Initial release. Closes: #971924

 -- Matija Nalis <mnalis-deb@voyager.hr>  Sat, 12 Dec 2020 15:26:26 +0100

=== debian/control ===
Source: ironseed
Section: games
Priority: optional
Maintainer: Matija Nalis <mnalis-deb@voyager.hr>
Build-Depends:
 debhelper (>=11~),
 debhelper-compat (= 13),
 fpc,
 gdc | ldc,
 graphicsmagick,
 imagemagick,
 libipc-system-simple-perl,
 libsdl-mixer1.2-dev,
 libsdl1.2-dev,
 perl,
Standards-Version: 4.5.1
Homepage: https://github.com/mnalis/ironseed_fpc
Vcs-Browser: https://salsa.debian.org/mnalis/ironseed
Vcs-Git: https://salsa.debian.org/mnalis/ironseed.git
Rules-Requires-Root: no

Package: ironseed
Architecture: amd64 arm64 armel armhf i386 mipsel mips64el ppc64el kfreebsd-amd64 kfreebsd-i386 riscv64
Multi-Arch: foreign
Depends:
 ironseed-data (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: science-fiction exploration/strategy adventure game in space
 It was originally both developed and published by Channel 7 for DOS in 1994.
 Gameplay is real-time, featuring trading, diplomacy, and strategy, and
 somewhat resembles Star Control 2 / Ur-Quan masters.
 .
 Storyline: Escaping the iron fist of a fanatic theocracy, the members of
 the Ironseed Movement launch into space and are set adrift after suffering
 a computer malfunction. As captain, you awaken along with the crew some
 thousand years later and are confronted by an alien horde...

Package: ironseed-data
Architecture: all
Multi-Arch: foreign
Recommends:
 ironseed (>= ${source:Version}),
Depends:
 ${misc:Depends},
Description: science-fiction exploration/strategy adventure game in space - data files
 It was originally both developed and published by Channel 7 for DOS in 1994.
 Gameplay is real-time, featuring trading, diplomacy, and strategy, and
 somewhat resembles Star Control 2 / Ur-Quan masters.
 .
 Storyline: Escaping the iron fist of a fanatic theocracy, the members of
 the Ironseed Movement launch into space and are set adrift after suffering
 a computer malfunction. As captain, you awaken along with the crew some
 thousand years later and are confronted by an alien horde...
 .
 This package provides the data files for the game.

=== debian/rules ===
#!/usr/bin/make -f

# we want debug info for stacktrace bugreports
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# extra hardening works on AMD64; but breaks on armel. Be conservative.
CPU_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH_CPU)
ifneq (,$(findstring hardening=+all,$(DEB_BUILD_MAINT_OPTIONS)))
ifeq (amd64,$(CPU_ARCH))
export LDFLAGS += -pie
endif
endif

# fpc(1) does not like to be run in parallel
%:
	dh $@ --no-parallel

override_dh_auto_install:
	dh_auto_install -- prefix=/usr libdir=/usr/libexec/ironseed

override_dh_auto_build:
# ppc64el (Bug#978153) and mipsel (Bug#980204) do not have working gdc, so skip rebuild of that
ifneq ($(filter ppc64el mipsel, $(CPU_ARCH)),)
	touch Data_Generators/makedata/convmake Data_Generators/makedata/logmake
	touch data/titles.dta data/log.dta data/conv*
endif
	dh_auto_build -- prefix=/usr libdir=/usr/libexec/ironseed

override_dh_installdocs:
	rm -f debian/ironseed-data/usr/share/doc/ironseed/*.6*
	dh_installdocs --exclude=.6

.PHONY: override_dh_auto_install override_dh_auto_build override_dh_installdocs

=== debian/tests/control ===
Tests: savegames
Architecture: amd64 arm64 armel armhf i386 mipsel mips64el ppc64el kfreebsd-amd64 kfreebsd-i386 riscv64
Depends:
 coreutils,
 ironseed,
 ironseed-data,
 sed,
 x11-apps,
 xauth,
 xdotool,
 xvfb,
Restrictions: flaky

## ironseed 0.4.0

=== Makefile ===
--- 
+++ 
@@ -24,9 +24,9 @@
 #fpc_debug += -Sewnh
 # -O- -Cr -CR -Ct   -gh  -gc -dDEBUG  -dTrace
 libgcc_dir := $(shell find /usr/ -name libgcc_s.so -printf "-Fl%h " 2>/dev/null)
-PFLAGS += -k-lSDL_mixer -k-lSDL -k-lm $(libgcc_dir)
-
-c_includes:=`sdl-config --cflags` -I /usr/X11R6/include
+PFLAGS += -k-lSDL2_mixer -k-lSDL2 -k-lm $(libgcc_dir)
+
+c_includes:=`sdl2-config --cflags` -I /usr/X11R6/include
 CFLAGS += -g -Wall -W -pedantic -Wno-unused-parameter -Wconversion $(c_includes)
 
 # PIE etc. hardening wanted by Debian - see https://wiki.debian.org/Hardening
@@ -46,29 +46,17 @@
 
 
 rebuild: clean all cleantmp
-# default target to build, best is debug_sdl / debug_ogl (NOT "release_xxx" AKA "no-checks" versions!)
+# default target to build, best is debug_sdl (NOT "release_sdl" AKA "no-checks" versions!)
 all: clearpaths debug_sdl1
 
 cleanbuild: clean build cleantmp
 
-# OpenGL no-checks version
-release_ogl debug_ogl1: PFLAGS += -k-lGL -k-lGLU
-
-release_ogl: CFLAGS += -O -DNDEBUG
-release_ogl: cleanbuild
-
-# OpenGL debug version
-debug_ogl:   clean debug_ogl1 cleantmp
-debug_ogl1:  CFLAGS += -O1 -Werror
-debug_ogl1:  PFLAGS += $(fpc_debug)
-debug_ogl1:  build
-
 # SDL no-checks version
-release_sdl: CFLAGS += -O -DNDEBUG -DNO_OGL
+release_sdl: CFLAGS += -O -DNDEBUG
 release_sdl: cleanbuild
 
 # SDL debug version
-debug_sdl1 demo_sdl1 data_build Data_Generators/makedata/iconmake Data_Generators/makedata/makeani Data_Generators/makedata/shp2make: CFLAGS += -O1 -DNO_OGL -Werror
+debug_sdl1 demo_sdl1 data_build Data_Generators/makedata/iconmake Data_Generators/makedata/makeani Data_Generators/makedata/shp2make: CFLAGS += -O1 -Werror
 
 debug_sdl:   clean debug_sdl1 cleantmp
 debug_sdl1:  PFLAGS += $(fpc_debug)
@@ -101,7 +89,7 @@
 	$(p_compiler) $(PFLAGS) $@.pas
 
 test/test_0_c: clean Makefile c_utils.c test/test_0_c.c
-	$(CC) $(CFLAGS) -O1 -Werror test/test_0_c.c `sdl-config --libs` -lSDL_mixer -lm -lGL -lGLU  -o test/test_0_c
+	$(CC) $(CFLAGS) -O1 -Werror test/test_0_c.c `sdl2-config --libs` -lSDL_mixer -lm -lGL -lGLU  -o test/test_0_c
 
 test/test_0_pas: CFLAGS += -O1 -Werror
 test/test_0_pas: PFLAGS += $(fpc_debug) -k-lGL -k-lGLU
@@ -218,3 +206,8 @@
 data/conv1103.dta: Data_Generators/makedata/tek5con1.txt Data_Generators/makedata/convmake
 
 data/charani.dta:     Data_Generators/makedata/makeani data/char.cpr Data_Generators/makedata/charani.cpr
+	Data_Generators/makedata/makeani
+data/shippix.dta:     Data_Generators/makedata/shp2make Data_Generators/makedata/shippart.cpr
+	Data_Generators/makedata/shp2make
+data/iteminfo.dta: Data_Generators/makedata/itemmake Data_Generators/makedata/iteminfo.txt
+	Data_Generators/makedata/itemmake > /dev/null

=== debian/changelog ===
ironseed (0.4.0-7) unstable; urgency=medium

  * try to make autopkgtest work on slower architectures like armel
  * avoid rare autopkgtest failure due to cursor color change
  * document test as flaky (just in case the above didn't help)
    Closes: #1077928
  * remove gdc data rebuild workaround for mipsel, as Bug#980204
    was resolved in Bookworm
  * update Standards-Version to 4.7.0

 -- Matija Nalis <mnalis-deb@voyager.hr>  Fri, 19 Apr 2024 02:16:12 +0000

ironseed (0.4.0-6) unstable; urgency=medium

  * temporarily remove strangely timeouting tests for armel,armhf,ppc64el

 -- Matija Nalis <mnalis-deb@voyager.hr>  Thu, 18 Apr 2024 14:21:04 +0000

ironseed (0.4.0-5) unstable; urgency=medium

  * ignore even more spurious "failed to load driver: zink" errors
    leading to autopkgtest failures
  * increase autopkgtest timeout for slower architectures

 -- Matija Nalis <mnalis-deb@voyager.hr>  Tue, 16 Apr 2024 14:23:25 +0200

ironseed (0.4.0-4) unstable; urgency=medium

  [ Matija Nalis ]
  * upgrades to upstream 0.4.0, with SDL2 support
    Closes: #1038461
  * hurd-i386 architecture should also be possible, if/when it has working
    dependencies
  * test should not be flaky (on supported architectures)
  * remove homepage entry from d/metadata, as not present in DEP12
  * fix LDFLAGS overwriting
  * update copyright year
  * removed graphicsmagick dependency (no longer needed with 0.3.7)
  * updates Standards-Version to 4.7.0
  * lintian fix package-contains-documentation-outside-usr-share-doc
  * autopkgtest workaround for ignorable errors
  * autopkgtest extra test for correct gamescreen
  * add salsa-ci.yml

 -- Matija Nalis <mnalis-deb@voyager.hr>  Sun, 14 Apr 2024 21:01:51 +0000

=== debian/control ===
--- 
+++ 
@@ -7,20 +7,19 @@
  debhelper-compat (= 13),
  fpc,
  gdc | ldc,
- graphicsmagick,
  imagemagick,
  libipc-system-simple-perl,
- libsdl-mixer1.2-dev,
- libsdl1.2-dev,
+ libsdl2-mixer-dev,
+ libsdl2-dev,
  perl,
-Standards-Version: 4.5.1
+Standards-Version: 4.7.0
 Homepage: https://github.com/mnalis/ironseed_fpc
 Vcs-Browser: https://salsa.debian.org/mnalis/ironseed
 Vcs-Git: https://salsa.debian.org/mnalis/ironseed.git
 Rules-Requires-Root: no
 
 Package: ironseed
-Architecture: amd64 arm64 armel armhf i386 mipsel mips64el ppc64el kfreebsd-amd64 kfreebsd-i386 riscv64
+Architecture: amd64 arm64 armel armhf i386 mipsel mips64el ppc64el kfreebsd-amd64 kfreebsd-i386 hurd-i386 riscv64
 Multi-Arch: foreign
 Depends:
  ironseed-data (= ${source:Version}),

=== debian/rules ===
--- 
+++ 
@@ -7,7 +7,7 @@
 CPU_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH_CPU)
 ifneq (,$(findstring hardening=+all,$(DEB_BUILD_MAINT_OPTIONS)))
 ifeq (amd64,$(CPU_ARCH))
-export LDFLAGS += -pie
+export LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS) -pie
 endif
 endif
 
@@ -19,8 +19,8 @@
 	dh_auto_install -- prefix=/usr libdir=/usr/libexec/ironseed
 
 override_dh_auto_build:
-# ppc64el (Bug#978153) and mipsel (Bug#980204) do not have working gdc, so skip rebuild of that
-ifneq ($(filter ppc64el mipsel, $(CPU_ARCH)),)
+# ppc64el (Bug#978153) does not have working gdc, so skip rebuild of that
+ifneq ($(filter ppc64el, $(CPU_ARCH)),)
 	touch Data_Generators/makedata/convmake Data_Generators/makedata/logmake
 	touch data/titles.dta data/log.dta data/conv*
 endif

=== debian/tests/control ===
Tests: savegames
Restrictions: flaky
Architecture: amd64 arm64 armel armhf i386 mipsel mips64el ppc64el kfreebsd-amd64 kfreebsd-i386 hurd-i386 riscv64
Depends:
 coreutils,
 ironseed,
 ironseed-data,
 sed,
 x11-apps,
 xauth,
 xdotool,
 xvfb,
 netpbm,

=== debian/watch ===
version=4

# PGP signature mangle, so foo.tar.gz has foo.tar.gz.asc
#opts="pgpsigurlmangle=s%$%.asc%"

opts="filenamemangle=s%(?:.*?)?fpc_(\d+)_(\d+)_(\d+)\.tar\.gz%ironseed_fpc-$1.$2.$3.tar.gz%" \
   https://github.com/mnalis/ironseed_fpc/tags \
   (?:.*?/)?fpc_(\d+)_(\d+)_(\d+)\.tar\.gz debian uupdate
